# Class to calculate Ackley's function
# Function taken from https://www.sfu.ca/~ssurjano/ackley.html
# May 3rd 2017
#
# Dr. Walter F. de Azevedo Jr.
# azevedolab.net
# May 3rd 2017
#

class Function3D(object):
    """Class to calculate a 3D function"""
    
    # Define constructor method
    def __init__(self):
        
        # Define attributes
        self.xmin = -32.768
        self.xmax = 32.768
        self.npoints = 300
        self.title = "Ackley's Function"
        self.output = "ackley.png"
        
    # Define __str__ method
    def __str__(self):
        info = "\nAckley's Function"
        info += "Global minimum: f(0,0) = 0"
        info += "Input domain: -32.768 <= x,y <= 32.768"
        return info
        
    # Define calc method
    def calc(self):
        """Method to calculate 3D function"""
        
        # Import library
        import numpy as np
        
        # Generate x and y axes
        x = np.outer(np.linspace(self.xmin, self.xmax, self.npoints), np.ones(self.npoints))
        y = x.copy().T
                
        # Generate f(x,y)
        a = 20
        b = 0.2
        c = 2*np.pi
        f = -a*np.exp(-b*np.sqrt( 0.5*(x**2 + y**2))) -np.exp(0.5*(np.cos(c*x) + np.cos(c*y))) + a + np.exp(1)
        
        # Return axes       
        return x,y,f,self.xmin,self.xmax,self.title,self.output