# Class to calculate Bukin Function N. 6
# Function taken from https://www.sfu.ca/~ssurjano/bukin6.html
# May 3rd 2017
#
# Dr. Walter F. de Azevedo Jr.
# azevedolab.net
# May 3rd 2017
#

class Function3D(object):
    """Class to calculate a 3D function"""
    
    # Define constructor method
    def __init__(self):
        
        # Define attributes
        self.xmin = -15
        self.xmax = 15
        self.npoints = 300
        self.title = "Bukin Function N. 6"
        self.output = "bukin6.png"
        
    # Define __str__ method
    def __str__(self):
        info = "\nBukin Function N. 6"
        info += "Global minimum: f(-10,1) = 0"
        info += "Input domain: -15 <= x <= -5 and -3 <= y <= 3"
        return info
        
    # Define calc method
    def calc(self):
        """Method to calculate 3D function"""
        
        # Import library
        import numpy as np
        
        # Generate x and y axes
        x = np.outer(np.linspace(self.xmin, self.xmax, self.npoints), np.ones(self.npoints))
        y = x.copy().T
                
        # Generate f(x,y)
        f = 100*np.sqrt( np.abs(y - 0.01*x**2)) + 0.01*np.abs(x + 10)
        
        # Return axes        
        return x,y,f,self.xmin,self.xmax,self.title,self.output