# Class to calculate Eggholder Function
# Function taken from https://www.sfu.ca/~ssurjano/egg.html
# May 3rd 2017
#
# Dr. Walter F. de Azevedo Jr.
# azevedolab.net
# May 4th 2017
#

class Function3D(object):
    """Class to calculate a 3D function"""
    
    # Define constructor method
    def __init__(self):
        
        # Define attributes
        self.xmin = -512
        self.xmax = 512
        self.npoints = 300
        self.title = "Eggholder Function"
        self.output = "eggholder.png"
        
    # Define __str__ method
    def __str__(self):
        info = "\nEggholder Function"
        info += "Global minimum: f(512,404.2319) = -959.6407"
        info += "Input domain: -512 <= x, y <= 512"
        return info
        
    # Define calc method
    def calc(self):
        """Method to calculate 3D function"""
        
        # Import library
        import numpy as np
        
        # Generate x and y axes
        x = np.outer(np.linspace(self.xmin, self.xmax, self.npoints), np.ones(self.npoints))
        y = x.copy().T
                
        # Generate f(x,y)
        f = -(y + 47)*np.sin( np.sqrt(   np.abs( y +x/2 +47 ) )   ) -x*np.sin(  np.sqrt( np.abs( x - (y+47) ) )  )
        
        # Return axes        
        return x,y,f,self.xmin,self.xmax,self.title,self.output