# Class to calculate Griewank Function
# Function taken from https://www.sfu.ca/~ssurjano/griewank.html
# May 3rd 2017
#
# Dr. Walter F. de Azevedo Jr.
# azevedolab.net
# May 4th 2017
#

class Function3D(object):
    """Class to calculate a 3D function"""
    
    # Define constructor method
    def __init__(self):
        
        # Define attributes
        self.xmin = -600
        self.xmax = 600
        self.npoints = 300
        self.title = "Griewank Function"
        self.output = "griewank.png"
        
    # Define __str__ method
    def __str__(self):
        info = "\nGriewank Function"
        info += "Global minimum: f(0,0) = 0"
        info += "Input domain: -600 <= x, y <= 600"
        return info
        
    # Define calc method
    def calc(self):
        """Method to calculate 3D function"""
        
        # Import library
        import numpy as np
        
        # Generate x and y axes
        x = np.outer(np.linspace(self.xmin, self.xmax, self.npoints), np.ones(self.npoints))
        y = x.copy().T
                
        # Generate f(x,y)
        f = (1/4000)*(x**2 + y**2) - np.cos(x)*np.cos(y/np.sqrt(2)) + 1
        
        # Return axes        
        return x,y,f,self.xmin,self.xmax,self.title,self.output